// ------------------------------------------------------------------------
// Copyright (C) 1996, ITS Information Technology Solutions GmbH.
//
// This file is part of ITSEDIPP, the IT Solutions EDI Pseudo Printer.
//
// ITSEDIPP is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// ITSEDIPP is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with ITSEDIPP; see the file COPYING.  If not, write to the
// Free Software Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// Support for ITSEDIPP can be obtained from (as of November 1996):
//	"IT Solutions"
//	ITS Information Technology Solutions GmbH
//	Balanstr. 69 / EG
//	D - 81541 Munich
//	Germany
//	Phone:	+49(89)400424
//	E-Mail:	100335.120@compuserve.com
// ------------------------------------------------------------------------
//
// HEADER SEPARATOR

#include	"itspmdde.h"

VOID INTERN
error(
	CLPCSTR	lpFunction,
	CLPCSTR	lpMessage,
	CLPCSTR	lpArgument,
	CDWORD	dwValue
	)
{
	static CHAR	cErrorMessage[512];

	if (lpArgument == NULL && dwValue == IPMD_NOARG)
		wsprintf(cErrorMessage, "%.48s: %.64s",
			lpFunction, lpMessage);
	else if (lpArgument == NULL && HIWORD(dwValue) == 0)
		wsprintf(cErrorMessage, "%.48s: %.64s: %04lX",
			lpFunction, lpMessage, dwValue);
	else if (lpArgument == NULL)
		wsprintf(cErrorMessage, "%.48s: %.64s: %08lX",
			lpFunction, lpMessage, dwValue);
	else if (dwValue == IPMD_NOARG)
		wsprintf(cErrorMessage, "%.48s: %.64s: %.80s",
			lpFunction, lpMessage, lpArgument);
	else if (HIWORD(dwValue) == 0)
		wsprintf(cErrorMessage, "%.48s: %.64s: %.80s: %04lX",
			lpFunction, lpMessage, lpArgument, dwValue);
	else
		wsprintf(cErrorMessage, "%.48s: %.64s: %.80s: %08lX",
			lpFunction, lpMessage, lpArgument, dwValue);
	convert_non_printable(cErrorMessage);

	if (hDialog != NULL)
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_ERROR, (LPARAM) cErrorMessage);

	_fstrcat(cErrorMessage, "\n");
	MessageBox(NULL, cErrorMessage, IPMD_SERVICE " Error Message",
			MB_TASKMODAL | MB_OK | MB_ICONEXCLAMATION);

	IFDBG(debug(lpFunction, lpMessage, lpArgument, dwValue));
}

#if	defined(_DEBUG)

VOID INTERN
debug(
	CLPCSTR	lpFunction,
	CLPCSTR	lpMessage,
	CLPCSTR	lpArgument,
	CDWORD	dwValue
	)
{
	static CHAR	cErrorMessage[512];

	if (lpArgument == NULL && dwValue == IPMD_NOARG)
		wsprintf(cErrorMessage, "xyzzy: %.48s: %.64s",
			lpFunction, lpMessage);
	else if (lpArgument == NULL && HIWORD(dwValue) == 0)
		wsprintf(cErrorMessage, "xyzzy: %.48s: %.64s: %04lX",
			lpFunction, lpMessage, dwValue);
	else if (lpArgument == NULL)
		wsprintf(cErrorMessage, "xyzzy: %.48s: %.64s: %08lX",
			lpFunction, lpMessage, dwValue);
	else if (dwValue == IPMD_NOARG)
		wsprintf(cErrorMessage, "xyzzy: %.48s: %.64s: %.80s",
			lpFunction, lpMessage, lpArgument);
	else if (HIWORD(dwValue) == 0)
		wsprintf(cErrorMessage, "xyzzy: %.48s: %.64s: %.80s: %04lX",
			lpFunction, lpMessage, lpArgument, dwValue);
	else
		wsprintf(cErrorMessage, "xyzzy: %.48s: %.64s: %.80s: %08lX",
			lpFunction, lpMessage, lpArgument, dwValue);
	convert_non_printable(cErrorMessage);

	_fstrcat(cErrorMessage, "\n");
	OutputDebugString(cErrorMessage);
}

#endif
