// ------------------------------------------------------------------------
// Copyright (C) 1996, ITS Information Technology Solutions GmbH.
//
// This file is part of ITSEDIPP, the IT Solutions EDI Pseudo Printer.
//
// ITSEDIPP is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// ITSEDIPP is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with ITSEDIPP; see the file COPYING.  If not, write to the
// Free Software Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// Support for ITSEDIPP can be obtained from (as of November 1996):
//	"IT Solutions"
//	ITS Information Technology Solutions GmbH
//	Balanstr. 69 / EG
//	D - 81541 Munich
//	Germany
//	Phone:	+49(89)400424
//	E-Mail:	100335.120@compuserve.com
// ------------------------------------------------------------------------
//
// HEADER SEPARATOR

#include	"itspmdde.h"

BOOL INTERN
got_CONNECTION(
	HCONV	hConv
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_CONNECTION, NULL);

	lpMessage = get_conv_message(hConv);
	if (lpMessage != NULL)
	{
		error("got_CONNECTION",
			"message buffer already exists", NULL, IPMD_NOARG);
		return(FALSE);
	}

	lpMessage = (LPIPMDMSG) _fmalloc(sizeof(IPMDMSG));
	if (lpMessage == NULL)
	{
		error("got_CONNECTION",
			"cannot alloc message buffer", NULL, IPMD_NOARG);
		return(FALSE);
	}

	clear_message(lpMessage);

	if (set_conv_message(hConv, lpMessage) == FALSE)
	{
		error("got_CONNECTION",
			"cannot set message buffer", NULL, IPMD_NOARG);
		return(FALSE);
	}

	return(TRUE);
}

BOOL INTERN
got_DISCONNECTION(
	HCONV	hConv
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_DISCONNECTION, NULL);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_DISCONNECTION",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	release_message_contents(lpMessage);

	_ffree(lpMessage);

	if (set_conv_message(hConv, NULL) == FALSE)
	{
		error("got_DISCONNECTION",
			"cannot set message buffer", NULL, IPMD_NOARG);
		return(FALSE);
	}

	return(TRUE);
}

BOOL INTERN
got_NEWMESSAGE(
	HCONV	hConv
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_NEWMESSAGE, NULL);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_NEWMESSAGE",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	release_message_contents(lpMessage);

	clear_message(lpMessage);

	return(TRUE);
}

BOOL INTERN
got_SETDEFAULTS(
	HCONV	hConv
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_SETDEFAULTS, NULL);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_SETDEFAULTS",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	lpMessage->bSetdefaultsSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_SENDMESSAGE(
	HCONV	hConv
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_SENDMESSAGE, NULL);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_SENDMESSAGE",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	if (send_message(lpMessage) == FALSE)
	{
		error("got_SENDMESSAGE",
			"error sending message", NULL, IPMD_NOARG);
		return(FALSE);
	}

	return(TRUE);
}

//	In all the following procedures which get an lpValue argument,
//	the lpValue will have been malloced by the caller, so it must
//	be saved somewhere from which it will be later freed, or it
//	must be freed right away.
//	So, if lpValue is saved, do not free it.  If the word_value()
//	of lpValue is taken, then free it.  If there is an error, then
//	do not save it, return FALSE and the caller will free lpValue.

BOOL INTERN
got_TO(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_TO, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_TO",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	//	only one TO allowed; subsequent overwrites earlier
	if (lpMessage->bToSet == TRUE && lpMessage->lpTo != NULL)
	{
		_ffree(lpMessage->lpTo);
		lpMessage->lpTo = NULL;
		lpMessage->bToSet = FALSE;
	}

	chop_crlf(lpValue);
	lpMessage->lpTo = lpValue;
	lpMessage->bToSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_CC(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_CC, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_CC",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	//	only one CC allowed; subsequent overwrites earlier
	if (lpMessage->bCcSet == TRUE && lpMessage->lpCc != NULL)
	{
		_ffree(lpMessage->lpCc);
		lpMessage->lpCc = NULL;
		lpMessage->bCcSet = FALSE;
	}

	chop_crlf(lpValue);
	lpMessage->lpCc = lpValue;
	lpMessage->bCcSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_BCC(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_BCC, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_BCC",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	//	only one BCC allowed; subsequent overwrites earlier
	if (lpMessage->bBccSet == TRUE && lpMessage->lpBcc != NULL)
	{
		_ffree(lpMessage->lpBcc);
		lpMessage->lpBcc = NULL;
		lpMessage->bBccSet = FALSE;
	}

	chop_crlf(lpValue);
	lpMessage->lpBcc = lpValue;
	lpMessage->bBccSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_SUBJECT(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_SUBJECT, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_SUBJECT",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	//	only one SUBJECT allowed; subsequent overwrites earlier
	if (lpMessage->bSubjectSet == TRUE && lpMessage->lpSubject != NULL)
	{
		_ffree(lpMessage->lpSubject);
		lpMessage->lpSubject = NULL;
		lpMessage->bSubjectSet = FALSE;
	}

	chop_crlf(lpValue);
	lpMessage->lpSubject = lpValue;
	lpMessage->bSubjectSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_COPYSELF(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_COPYSELF, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_COPYSELF",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	chop_crlf(lpValue);
	lpMessage->wCopyself = word_value(lpValue);
	_ffree(lpValue);
	lpMessage->bCopyselfSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_CONFIRMREADING(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_CONFIRMREADING, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_CONFIRMREADING",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	chop_crlf(lpValue);
	lpMessage->wConfirmreading = word_value(lpValue);
	_ffree(lpValue);
	lpMessage->bConfirmreadingSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_CONFIRMDELIVERY(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_CONFIRMDELIVERY, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_CONFIRMDELIVERY",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	chop_crlf(lpValue);
	lpMessage->wConfirmdelivery = word_value(lpValue);
	_ffree(lpValue);
	lpMessage->bConfirmdeliverySet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_URGENT(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_URGENT, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_URGENT",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	chop_crlf(lpValue);
	lpMessage->wUrgent = word_value(lpValue);
	_ffree(lpValue);
	lpMessage->bUrgentSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_MIME(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_MIME, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_MIME",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	chop_crlf(lpValue);
	lpMessage->wMime = word_value(lpValue);
	_ffree(lpValue);
	lpMessage->bMimeSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_8BITDATA(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_8BITDATA, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_8BITDATA",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	chop_crlf(lpValue);
	lpMessage->w8bitdata = word_value(lpValue);
	_ffree(lpValue);
	lpMessage->b8bitdataSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_REPLYTO(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_REPLYTO, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_REPLYTO",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	//	only one REPLYTO allowed; subsequent overwrites earlier
	if (lpMessage->bReplytoSet == TRUE && lpMessage->lpReplyto != NULL)
	{
		_ffree(lpMessage->lpReplyto);
		lpMessage->lpReplyto = NULL;
		lpMessage->bReplytoSet = FALSE;
	}

	chop_crlf(lpValue);
	lpMessage->lpReplyto = lpValue;
	lpMessage->bReplytoSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_ATTACHFILE(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;
	WORD		wAttNum;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_ATTACHFILE, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_ATTACHFILE",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	// up to IPMD_MAXATTACH attachments allowed
	if (lpMessage->wNumAttachments == IPMD_MAXATTACH)
	{
		error("got_ATTACHFILE",
			"too many attachments", NULL, (DWORD) IPMD_MAXATTACH);
		return(FALSE);
	}

	wAttNum = lpMessage->wNumAttachments;

	//	if current slot not empty, clear it
	if (lpMessage->lpAttachfiles[wAttNum] != NULL)
	{
		_ffree(lpMessage->lpAttachfiles[wAttNum]);
		lpMessage->lpAttachfiles[wAttNum] = NULL;
	}

	chop_crlf(lpValue);
	lpMessage->lpAttachfiles[wAttNum] = lpValue;
	++(lpMessage->wNumAttachments);

	return(TRUE);
}

BOOL INTERN
got_ATTACHTYPE(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;
	WORD		wAttNum;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_ATTACHTYPE, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_ATTACHTYPE",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	// must have called ATTACHFILE first
	if (lpMessage->wNumAttachments == 0)
	{
		error("got_ATTACHTYPE",
			"must call ATTACHFILE before ATTACHTYPE", NULL, IPMD_NOARG);
		return(FALSE);
	}

	wAttNum = (lpMessage->wNumAttachments) - 1;

	//	only one TYPE per FILE allowed; subsequent overwrites earlier
	if (lpMessage->lpAttachtypes[wAttNum] != NULL)
	{
		_ffree(lpMessage->lpAttachtypes[wAttNum]);
		lpMessage->lpAttachtypes[wAttNum] = NULL;
	}

	chop_crlf(lpValue);
	lpMessage->lpAttachtypes[wAttNum] = lpValue;

	return(TRUE);
}

BOOL INTERN
got_ATTACHENCODING(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;
	WORD		wAttNum;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_ATTACHENCODING, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_ATTACHENCODING",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	// must have called ATTACHFILE first
	if (lpMessage->wNumAttachments == 0)
	{
		error("got_ATTACHENCODING",
			"must call ATTACHFILE before ATTACHENCODING", NULL, IPMD_NOARG);
		return(FALSE);
	}

	wAttNum = (lpMessage->wNumAttachments) - 1;

	chop_crlf(lpValue);
	lpMessage->wAttachencodings[wAttNum] = word_value(lpValue);
	_ffree(lpValue);

	return(TRUE);
}

BOOL INTERN
got_ENCRYPTIONKEY(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_ENCRYPTIONKEY, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_ENCRYPTIONKEY",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	//	only one ENCRYPTIONKEY allowed; subsequent overwrites earlier
	if (lpMessage->bEncryptionkeySet == TRUE && lpMessage->lpEncryptionkey != NULL)
	{
		_ffree(lpMessage->lpEncryptionkey);
		lpMessage->lpEncryptionkey = NULL;
		lpMessage->bEncryptionkeySet = FALSE;
	}

	chop_crlf(lpValue);
	lpMessage->lpEncryptionkey = lpValue;
	lpMessage->bEncryptionkeySet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_NOSIG(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_NOSIG, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_NOSIG",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	chop_crlf(lpValue);
	lpMessage->wNosig = word_value(lpValue);
	_ffree(lpValue);
	lpMessage->bNosigSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_MESSAGEFILE(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_MESSAGEFILE, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_MESSAGEFILE",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	//	only one of MESSAGEFILE or MESSAGETEXT can be specified
	if (lpMessage->bMessagetextSet == TRUE && lpMessage->lpMessagetext != NULL)
	{
		_ffree(lpMessage->lpMessagetext);
		lpMessage->lpMessagetext = NULL;
		lpMessage->bMessagetextSet = FALSE;
	}

	//	only one MESSAGEFILE allowed; subsequent overwrites earlier
	if (lpMessage->bMessagefileSet == TRUE && lpMessage->lpMessagefile != NULL)
	{
		_ffree(lpMessage->lpMessagefile);
		lpMessage->lpMessagefile = NULL;
		lpMessage->bMessagefileSet = FALSE;
	}

	chop_crlf(lpValue);
	lpMessage->lpMessagefile = lpValue;
	lpMessage->bMessagefileSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_MESSAGETEXT(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_MESSAGETEXT, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_MESSAGETEXT",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	//	only one of MESSAGEFILE or MESSAGETEXT can be specified
	if (lpMessage->bMessagefileSet == TRUE && lpMessage->lpMessagefile != NULL)
	{
		_ffree(lpMessage->lpMessagefile);
		lpMessage->lpMessagefile = NULL;
		lpMessage->bMessagefileSet = FALSE;
	}

	//	only one MESSAGETEXT allowed; subsequent overwrites earlier
	if (lpMessage->bMessagetextSet == TRUE && lpMessage->lpMessagetext != NULL)
	{
		_ffree(lpMessage->lpMessagetext);
		lpMessage->lpMessagetext = NULL;
		lpMessage->bMessagetextSet = FALSE;
	}

	convert_crlf(lpValue);
	lpMessage->lpMessagetext = lpValue;
	lpMessage->bMessagetextSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_EXPIRATION(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_EXPIRATION, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_EXPIRATION",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	//	only one EXPIRATION allowed; subsequent overwrites earlier
	if (lpMessage->bExpirationSet == TRUE && lpMessage->lpExpiration != NULL)
	{
		_ffree(lpMessage->lpExpiration);
		lpMessage->lpExpiration = NULL;
		lpMessage->bExpirationSet = FALSE;
	}

	chop_crlf(lpValue);
	lpMessage->lpExpiration = lpValue;
	lpMessage->bExpirationSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_SETHEADERTYPE(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_SETHEADERTYPE, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_SETHEADERTYPE",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	chop_crlf(lpValue);
	lpMessage->wSetheadertype = word_value(lpValue);
	_ffree(lpValue);
	lpMessage->bSetheadertypeSet = TRUE;

	return(TRUE);
}

BOOL INTERN
got_SETHEADER(
	HCONV	hConv,
	LPSTR	lpValue
	)
{
	LPIPMDMSG	lpMessage;

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GOT_SETHEADER, (LPARAM) lpValue);

	lpMessage = get_conv_message(hConv);
	if (lpMessage == NULL)
	{
		error("got_SETHEADER",
			"message buffer does not exist", NULL, IPMD_NOARG);
		return(FALSE);
	}

	//	only one SETHEADER allowed; subsequent overwrites earlier
	if (lpMessage->bSetheaderSet == TRUE && lpMessage->lpSetheader != NULL)
	{
		_ffree(lpMessage->lpSetheader);
		lpMessage->lpSetheader = NULL;
		lpMessage->bSetheaderSet = FALSE;
	}

	convert_crlf(lpValue);
	lpMessage->lpSetheader = lpValue;
	lpMessage->bSetheaderSet = TRUE;

	return(TRUE);
}
