// ------------------------------------------------------------------------
// Copyright (C) 1996, ITS Information Technology Solutions GmbH.
//
// This file is part of ITSEDIPP, the IT Solutions EDI Pseudo Printer.
//
// ITSEDIPP is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// ITSEDIPP is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with ITSEDIPP; see the file COPYING.  If not, write to the
// Free Software Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// Support for ITSEDIPP can be obtained from (as of November 1996):
//	"IT Solutions"
//	ITS Information Technology Solutions GmbH
//	Balanstr. 69 / EG
//	D - 81541 Munich
//	Germany
//	Phone:	+49(89)400424
//	E-Mail:	100335.120@compuserve.com
// ------------------------------------------------------------------------
//
// HEADER SEPARATOR

#if	! defined(_INC_ITS_ITSPMDDE_H_)
#define	_INC_ITS_ITSPMDDE_H_

#define	BUILDDLL
#define	STRICT

#include	<windows.h>
#include	<stdlib.h>
#include	<malloc.h>
#include	<string.h>
#include	<ddeml.h>

#if	defined(ITS_PMDDE)
#include	<wpmforms.h>
#endif

#define	EXPORT	__export WINAPI
#define	INTERN	FAR PASCAL

#define	CHAR	char
#define	CONST	const
#define	INT	int
#define	STR	char

typedef STR CONST	CSTR;
typedef CSTR FAR*	LPCSTR;
typedef LPCSTR CONST	CLPCSTR;
typedef STR FAR*	LPSTR;
typedef LPSTR CONST	CLPSTR;

typedef DWORD CONST	CDWORD;
typedef HMODULE CONST	CHMODULE;
typedef INT CONST	CINT;
typedef WORD CONST	CWORD;

typedef HWND CONST	CHWND;
typedef HWND FAR*	LPHWND;
typedef LPHWND CONST	CLPHWND;

#if	defined(_DEBUG)
#define	IFDBG(arg)	arg
#else
#define	IFDBG(arg)	/* nothing */
#endif

#if	defined(USEOWNCLASS)
#define	IPMD_DCLASS	"ITSPMDDE"
#endif
#define	IPMD_DIALOG	"ITSPMDDE"
#define	IPMD_SERVICE	"ITSPMDDE"
#define	IPMD_TOPIC	"SENDMAIL"
#define	IPMD_EDITBOX	10101
#define	IPMD_NOARG	0x80000000
#define	IPMD_MAXATTACH	64

#define	IPMD_BASE			(0x7700)
#define	IPMD_LOGEVENT			(IPMD_BASE + 0x00)
#define	IPMD_DDESTART			(IPMD_BASE + 0x01)
#define	IPMD_DDESTOP			(IPMD_BASE + 0x02)
#define	IPMD_DDECALLBACK		(IPMD_BASE + 0x03)
#define	IPMD_GOT_CONNECTION		(IPMD_BASE + 0x04)
#define	IPMD_GOT_DISCONNECTION		(IPMD_BASE + 0x05)
#define	IPMD_GOT_NEWMESSAGE		(IPMD_BASE + 0x06)
#define	IPMD_GOT_SETDEFAULTS		(IPMD_BASE + 0x07)
#define	IPMD_GOT_SENDMESSAGE		(IPMD_BASE + 0x08)
#define	IPMD_GOT_TO			(IPMD_BASE + 0x09)
#define	IPMD_GOT_CC			(IPMD_BASE + 0x0A)
#define	IPMD_GOT_BCC			(IPMD_BASE + 0x0B)
#define	IPMD_GOT_SUBJECT		(IPMD_BASE + 0x0C)
#define	IPMD_GOT_COPYSELF		(IPMD_BASE + 0x0D)
#define	IPMD_GOT_CONFIRMREADING		(IPMD_BASE + 0x0E)
#define	IPMD_GOT_CONFIRMDELIVERY	(IPMD_BASE + 0x0F)
#define	IPMD_GOT_URGENT			(IPMD_BASE + 0x10)
#define	IPMD_GOT_MIME			(IPMD_BASE + 0x11)
#define	IPMD_GOT_8BITDATA		(IPMD_BASE + 0x12)
#define	IPMD_GOT_REPLYTO		(IPMD_BASE + 0x13)
#define	IPMD_GOT_ATTACHFILE		(IPMD_BASE + 0x14)
#define	IPMD_GOT_ATTACHTYPE		(IPMD_BASE + 0x15)
#define	IPMD_GOT_ATTACHENCODING		(IPMD_BASE + 0x16)
#define	IPMD_GOT_ENCRYPTIONKEY		(IPMD_BASE + 0x17)
#define	IPMD_GOT_NOSIG			(IPMD_BASE + 0x18)
#define	IPMD_GOT_MESSAGEFILE		(IPMD_BASE + 0x19)
#define	IPMD_GOT_MESSAGETEXT		(IPMD_BASE + 0x1A)
#define	IPMD_GOT_EXPIRATION		(IPMD_BASE + 0x1B)
#define	IPMD_GOT_SETHEADERTYPE		(IPMD_BASE + 0x1C)
#define	IPMD_GOT_SETHEADER		(IPMD_BASE + 0x1D)
#define	IPMD_GET_CONV_MESSAGE		(IPMD_BASE + 0x1E)
#define	IPMD_SET_CONV_MESSAGE		(IPMD_BASE + 0x1F)
#define	IPMD_CLEAR_MESSAGE		(IPMD_BASE + 0x20)
#define	IPMD_RELEASE_MESSAGE_CONTENTS	(IPMD_BASE + 0x21)
#define	IPMD_SEND_MESSAGE		(IPMD_BASE + 0x22)
#define	IPMD_ERROR			(IPMD_BASE + 0x23)

extern HMODULE	hDLLModule;
extern HWND	hMDI;
extern HWND	hDialog;
extern DWORD	dwIDInst;

struct itspmdde_message
{
	BOOL		bSetdefaultsSet;
	BOOL		bToSet;
	LPSTR		lpTo;
	BOOL		bCcSet;
	LPSTR		lpCc;
	BOOL		bBccSet;
	LPSTR		lpBcc;
	BOOL		bSubjectSet;
	LPSTR		lpSubject;
	BOOL		bCopyselfSet;
	WORD		wCopyself;
	BOOL		bConfirmreadingSet;
	WORD		wConfirmreading;
	BOOL		bConfirmdeliverySet;
	WORD		wConfirmdelivery;
	BOOL		bUrgentSet;
	WORD		wUrgent;
	BOOL		bMimeSet;
	WORD		wMime;
	BOOL		b8bitdataSet;
	WORD		w8bitdata;
	BOOL		bReplytoSet;
	LPSTR		lpReplyto;
	WORD		wNumAttachments;
	LPSTR		lpAttachfiles[IPMD_MAXATTACH];
	LPSTR		lpAttachtypes[IPMD_MAXATTACH];
	WORD		wAttachencodings[IPMD_MAXATTACH];
	BOOL		bEncryptionkeySet;
	LPSTR		lpEncryptionkey;
	BOOL		bNosigSet;
	WORD		wNosig;
	BOOL		bMessagefileSet;
	LPSTR		lpMessagefile;
	BOOL		bMessagetextSet;
	LPSTR		lpMessagetext;
	BOOL		bExpirationSet;
	LPSTR		lpExpiration;
	BOOL		bSetheadertypeSet;
	WORD		wSetheadertype;
	BOOL		bSetheaderSet;
	LPSTR		lpSetheader;
};

typedef struct itspmdde_message	IPMDMSG;
typedef IPMDMSG FAR*		LPIPMDMSG;

#endif

// itspmdde.c
extern	int __pascal __far __export __loadds LibMain(const struct HINSTANCE__ __near *hModule,const unsigned short wDataSeg,const unsigned short wHeapSize,const char __far *lpNotUsed);
extern	int __pascal __far __export __loadds WEP(const int iSystemExit);
// dde.c
extern	void __pascal __far DDEStart(const struct HWND__ __near *hWnd);
extern	void __pascal __far DDEStop(const struct HWND__ __near *hWnd);
extern	const struct HDDEDATA__ __far *__pascal __far __export __loadds DDECallback(unsigned int iType,unsigned int iFmt,const struct HCONV__ __far *hConv,const struct HSZ__ __far *hsz1,const struct HSZ__ __far *hsz2,const struct HDDEDATA__ __far *hData,unsigned long dwData1,unsigned long dwData2);
// dialog.c
extern	int __pascal __far __export __loadds DlgProc(const struct HWND__ __near *hWnd,unsigned short wMsg,unsigned int wParam,long lParam);
extern	void __pascal __far LogEvent(const struct HWND__ __near *hWnd,unsigned int wParam,long lParam);
// error.c
extern	void __pascal __far error(const char __far *lpFunction,const char __far *lpMessage,const char __far *lpArgument,const unsigned long dwValue);
extern	void __pascal __far debug(const char __far *lpFunction,const char __far *lpMessage,const char __far *lpArgument,const unsigned long dwValue);
// fillmsg.c
extern	int __pascal __far got_CONNECTION(const struct HCONV__ __far *hConv);
extern	int __pascal __far got_DISCONNECTION(const struct HCONV__ __far *hConv);
extern	int __pascal __far got_NEWMESSAGE(const struct HCONV__ __far *hConv);
extern	int __pascal __far got_SETDEFAULTS(const struct HCONV__ __far *hConv);
extern	int __pascal __far got_SENDMESSAGE(const struct HCONV__ __far *hConv);
extern	int __pascal __far got_TO(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_CC(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_BCC(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_SUBJECT(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_COPYSELF(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_CONFIRMREADING(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_CONFIRMDELIVERY(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_URGENT(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_MIME(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_8BITDATA(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_REPLYTO(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_ATTACHFILE(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_ATTACHTYPE(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_ATTACHENCODING(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_ENCRYPTIONKEY(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_NOSIG(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_MESSAGEFILE(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_MESSAGETEXT(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_EXPIRATION(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_SETHEADERTYPE(const struct HCONV__ __far *hConv,char __far *lpValue);
extern	int __pascal __far got_SETHEADER(const struct HCONV__ __far *hConv,char __far *lpValue);
// forminit.c
extern	unsigned short __pascal __far __export __loadds FORMINIT(const unsigned short wVersion,const int iVariant,const struct HWND__ __near *hParent,char __far *const lpData,const struct HWND__ __near *__far *lphDialog ,char __far *const lpCallback);
// msgbuf.c
extern	struct itspmdde_message __far *__pascal __far get_conv_message(const struct HCONV__ __far *hConv);
extern	int __pascal __far set_conv_message(const struct HCONV__ __far *hConv,struct itspmdde_message __far *lpMessage);
extern	void __pascal __far clear_message(struct itspmdde_message __far *lpMessage);
extern	void __pascal __far release_message_contents(struct itspmdde_message __far *lpMessage);
extern	char __far *__pascal __far string_value(const char __far *lpValue,const unsigned short wLen);
extern	unsigned short __pascal __far word_value(const char __far *lpValue);
extern	void __pascal __far chop_crlf(char __far *const lpValue);
extern	void __pascal __far convert_crlf(char __far *const lpValue);
extern	void __pascal __far convert_non_printable(char __far *lpValue);
// sendmsg.c
extern	int __pascal __far send_message(struct itspmdde_message __far *lpMessage);
