// ------------------------------------------------------------------------
// Copyright (C) 1996, ITS Information Technology Solutions GmbH.
//
// This file is part of ITSEDIPP, the IT Solutions EDI Pseudo Printer.
//
// ITSEDIPP is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// ITSEDIPP is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with ITSEDIPP; see the file COPYING.  If not, write to the
// Free Software Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// Support for ITSEDIPP can be obtained from (as of November 1996):
//	"IT Solutions"
//	ITS Information Technology Solutions GmbH
//	Balanstr. 69 / EG
//	D - 81541 Munich
//	Germany
//	Phone:	+49(89)400424
//	E-Mail:	100335.120@compuserve.com
// ------------------------------------------------------------------------
//
// HEADER SEPARATOR

#include	"itspmdde.h"

LPIPMDMSG INTERN
get_conv_message(
	HCONV		hConv
	)
{
	CONVINFO	ConvInfo;

	IFDBG(SendMessage(hDialog, IPMD_LOGEVENT, IPMD_GET_CONV_MESSAGE, NULL));

	ConvInfo.cb = sizeof(CONVINFO);

	if (DdeQueryConvInfo(hConv, (DWORD) QID_SYNC, &ConvInfo) == 0)
	{
		error("get_conv_message",
			"cannot get DDE conversation info", NULL,
					(DWORD) DdeGetLastError(dwIDInst));
		return(NULL);
	}

	return((LPIPMDMSG) (ConvInfo.hUser));
}

BOOL INTERN
set_conv_message(
	HCONV		hConv,
	LPIPMDMSG	lpMessage
	)
{
	IFDBG(SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SET_CONV_MESSAGE, NULL));

	if (DdeSetUserHandle(hConv, (DWORD) QID_SYNC, (DWORD) lpMessage) == FALSE)
	{
		error("set_conv_message",
			"cannot set DDE user info", NULL,
					(DWORD) DdeGetLastError(dwIDInst));
		return(FALSE);
	}

	return(TRUE);
}

VOID INTERN
clear_message(
	LPIPMDMSG	lpMessage
	)
{
	WORD	wAttNum;

	IFDBG(SendMessage(hDialog, IPMD_LOGEVENT, IPMD_CLEAR_MESSAGE, NULL));

	lpMessage->bSetdefaultsSet = FALSE;
	lpMessage->bToSet = FALSE;
	lpMessage->lpTo = NULL;
	lpMessage->bCcSet = FALSE;
	lpMessage->lpCc = NULL;
	lpMessage->bBccSet = FALSE;
	lpMessage->lpBcc = NULL;
	lpMessage->bSubjectSet = FALSE;
	lpMessage->lpSubject = NULL;
	lpMessage->bCopyselfSet = FALSE;
	lpMessage->wCopyself = 0;
	lpMessage->bConfirmreadingSet = FALSE;
	lpMessage->wConfirmreading = 0;
	lpMessage->bConfirmdeliverySet = FALSE;
	lpMessage->wConfirmdelivery = 0;
	lpMessage->bUrgentSet = FALSE;
	lpMessage->wUrgent = 0;
	lpMessage->bMimeSet = FALSE;
	lpMessage->wMime = 0;
	lpMessage->b8bitdataSet = FALSE;
	lpMessage->w8bitdata = 0;
	lpMessage->bReplytoSet = FALSE;
	lpMessage->lpReplyto = NULL;
	lpMessage->wNumAttachments = 0;
	for (wAttNum = 0; wAttNum < IPMD_MAXATTACH; ++wAttNum)
	{
		lpMessage->lpAttachfiles[wAttNum] = NULL;
		lpMessage->lpAttachtypes[wAttNum] = NULL;
		lpMessage->wAttachencodings[wAttNum] = 0;
	}
	lpMessage->bEncryptionkeySet = FALSE;
	lpMessage->lpEncryptionkey = NULL;
	lpMessage->bNosigSet = FALSE;
	lpMessage->wNosig = 0;
	lpMessage->bMessagefileSet = FALSE;
	lpMessage->lpMessagefile = NULL;
	lpMessage->bMessagetextSet = FALSE;
	lpMessage->lpMessagetext = NULL;
	lpMessage->bExpirationSet = FALSE;
	lpMessage->lpExpiration = NULL;
	lpMessage->bSetheadertypeSet = FALSE;
	lpMessage->wSetheadertype = 0;
	lpMessage->bSetheaderSet = FALSE;
	lpMessage->lpSetheader = NULL;
}

VOID INTERN
release_message_contents(
	LPIPMDMSG	lpMessage
	)
{
	WORD	wAttNum;

	IFDBG(SendMessage(hDialog, IPMD_LOGEVENT, IPMD_RELEASE_MESSAGE_CONTENTS, NULL));

	if (lpMessage->bToSet == TRUE && lpMessage->lpTo != NULL)
		_ffree(lpMessage->lpTo);
	if (lpMessage->bCcSet == TRUE && lpMessage->lpCc != NULL)
		_ffree(lpMessage->lpCc);
	if (lpMessage->bBccSet == TRUE && lpMessage->lpBcc != NULL)
		_ffree(lpMessage->lpBcc);
	if (lpMessage->bSubjectSet == TRUE && lpMessage->lpSubject != NULL)
		_ffree(lpMessage->lpSubject);
	if (lpMessage->bReplytoSet == TRUE && lpMessage->lpReplyto != NULL)
		_ffree(lpMessage->lpReplyto);
	for (wAttNum = 0; wAttNum < IPMD_MAXATTACH; ++wAttNum)
	{
		if (lpMessage->lpAttachfiles[wAttNum] != NULL)
			_ffree(lpMessage->lpAttachfiles[wAttNum]);
		if (lpMessage->lpAttachtypes[wAttNum] != NULL)
			_ffree(lpMessage->lpAttachtypes[wAttNum]);
	}
	if (lpMessage->bEncryptionkeySet == TRUE && lpMessage->lpEncryptionkey != NULL)
		_ffree(lpMessage->lpEncryptionkey);
	if (lpMessage->bMessagefileSet == TRUE && lpMessage->lpMessagefile != NULL)
		_ffree(lpMessage->lpMessagefile);
	if (lpMessage->bMessagetextSet == TRUE && lpMessage->lpMessagetext != NULL)
		_ffree(lpMessage->lpMessagetext);
	if (lpMessage->bExpirationSet == TRUE && lpMessage->lpExpiration != NULL)
		_ffree(lpMessage->lpExpiration);
	if (lpMessage->bSetheaderSet == TRUE && lpMessage->lpSetheader != NULL)
		_ffree(lpMessage->lpSetheader);
}

//	string_value() always returns a newly-allocated nul-terminated
//	string.  If the original string was not nul-terminated, then an
//	extra byte is allocated.  If the original string was NULL or had
//	no length, then an empty string is allocated and returned.
//	The ultimate recipient is responsible for freeing the string.

LPSTR INTERN
string_value(
	CLPCSTR	lpValue,
	CWORD	wLen
	)
{
	LPSTR	lpNew;
	WORD	wNewLen;

	if (lpValue == NULL || wLen == 0)
		wNewLen = 1;
	else if (lpValue[wLen - 1] != '\0')
		wNewLen = wLen + 1;
	else
		wNewLen = wLen;

	lpNew = _fmalloc(wNewLen);
	if (lpNew == NULL)
	{
		error("string_value",
			"cannot allocate string buffer", NULL, (DWORD) wNewLen);
		return(NULL);
	}

	if (lpValue != NULL && wLen != 0)
		_fmemcpy(lpNew, lpValue, wLen);
	lpNew[wNewLen - 1] = '\0';

	return(lpNew);
}

//	word_value() expects a nul-terminated string.

WORD INTERN
word_value(
	LPCSTR	lpValue
	)
{
	if (lpValue == NULL)
		return(0);
	while (*lpValue != '\0')
	{
		switch (*lpValue)
		{
		case '-': case '+': case '0': case '1':
		case '2': case '3': case '4': case '5':
		case '6': case '7': case '8': case '9':
			return(atoi(lpValue));

		case 't': case 'T': // true
		case 'y': case 'Y': // yes
		case 'w': case 'W': // wahr
		case 'j': case 'J': // ja
		case 'v': case 'V': // vrai
		case 'o': case 'O': // oui
		case 's': case 'S': // si
			return(1);

		case 'f': case 'F': // false, falsch, faux
		case 'n': case 'N': // no, nein, non
			return(0);

		default:
			++lpValue;
		}
	}
	return(0);
}

//	chop_crlf() expects a writable nul-terminated string.
//	It removes the trailing <CR>s and <LF>s from a string.

VOID INTERN
chop_crlf(
	CLPSTR	lpValue
	)
{
	WORD	wLen;
	CHAR	c;

	if (lpValue == NULL)
		return;

	wLen = _fstrlen(lpValue);

	while (wLen != 0)
	{
		--wLen;
		c = lpValue[wLen];
		if (c != '\n' && c != '\r')
			break;
		lpValue[wLen] = '\0';
	}
}

//	convert_crlf() expects a writable nul-terminated string.
//	It converts all <CR>, <LF>, <CR><LF> or <LF><CR> sequences to <LF>.

VOID INTERN
convert_crlf(
	CLPSTR	lpValue
	)
{
	LPSTR	lpWrite;
	LPSTR	lpRead;

	lpWrite = lpRead = lpValue;

	while (*lpRead != '\0')
	{
		if (*lpRead == '\r')
		{
			*lpWrite = '\n';
			++lpRead;
			if (*lpRead == '\n')
				++lpRead;
		}
		else if (*lpRead == '\n')
		{
			*lpWrite = '\n';
			++lpRead;
			if (*lpRead == '\r')
				++lpRead;
		}
		else
		{
			*lpWrite = *lpRead;
			++lpRead;
		}
		++lpWrite;
	}
	*lpWrite = '\0';
}

//	convert_non_printable() expects a writable nul-terminated string.
//	It converts all non-printable characters to question marks.

VOID INTERN
convert_non_printable(
	LPSTR	lpValue
	)
{
	CHAR	c;

	while ((c = *lpValue) != '\0')
	{
		if (c < ' ' || '~' < c)
			*lpValue = '?';
		++lpValue;
	}
}
